{{- range $NodeName,$NodeValues := .Values.nodes }}
{{ if not (default $NodeValues.disabled false) }}
---
apiVersion: metal3.io/v1alpha1
kind: BareMetalHost
metadata:
  name: {{ $NodeName }}
  labels:
    {{- include "metal3-bmh.labels" $ | nindent 4 }}
    {{- $NodeValues.labels | toYaml | nindent 4 }}
  {{- with $NodeValues.annotations }}
  annotations:
    {{- . | toYaml | nindent 4 }}
  {{- end }}
spec:
  {{- with $NodeValues.automatedCleaningMode }}
  automatedCleaningMode: {{ . }}
  {{- end }}
  {{- with $NodeValues.bootMACAddress }}
  bootMACAddress: {{ . }}
  {{- end }}
  {{- with $NodeValues.bootMode }}
  bootMode: {{ . }}
  {{- end }}
  {{- with $NodeValues.bmc }}
  bmc:
    address: {{ .address }}
    credentialsName: {{ include "metal3-bmh.hashedname" (dict "name" (printf "%s-%s" $NodeName "credentials") "data" .credentials) }}
  {{- end }}
  {{- with $NodeValues.networkData }}
  networkData:
    name: {{ include "metal3-bmh.hashedname" (dict "name" (printf "%s-%s" $NodeName "networkdata")  "data" .) }}
  {{- end}}
  {{- with $NodeValues.rootDeviceHints }}
  rootDeviceHints: 
    {{- . | toYaml | nindent 4 }}
  {{- end }}
---
{{- with $NodeValues.bmc }}
apiVersion: v1
kind: Secret
metadata:
  name: {{ include "metal3-bmh.hashedname" (dict "name" (printf "%s-%s" $NodeName "credentials") "data" .credentials) }} 
  labels:
    {{- include "metal3-bmh.labels" $ | nindent 4 }}
data:
  username: {{ .credentials.username | b64enc }}
  password: {{ .credentials.password | b64enc }}
{{- end }}
---
{{- with $NodeValues.networkData }}
apiVersion: v1
kind: Secret
metadata:
  name: {{ include "metal3-bmh.hashedname" (dict "name" (printf "%s-%s" $NodeName "networkdata") "data" .) }}
  labels:
    {{- include "metal3-bmh.labels" $ | nindent 4 }}
stringData:
  networkData: |-
    {{- . | toYaml | nindent 4 }} 
{{- end }}
{{- end }}
{{- end }}
